{-# LANGUAGE OverloadedStrings #-}

module Gitea.Preview.Markdown where

import Data.Default (def)
import Text.Pandoc (Pandoc, PandocError, ReaderOptions(..), readMarkdown, runPure, handleError, pandocExtensions, writeHtml5String)
import Data.Text (Text)

import qualified Data.Text.IO as T

import Gitea.Preview.Markdown.Math
import Gitea.Preview.Markdown.Meta
import Gitea.Preview.Markdown.Signatures

main :: IO ()
main = do
    input <- T.getContents
    pandoc <- handleError $ readMD input
    out <- handleError $ runPure $ writeHtml5String def $ pandocFilter pandoc
    T.putStr out

pandocFilter :: Pandoc -> Pandoc
pandocFilter = renderSignatures'
    . katexMath'
    . renderMeta'

readMD :: Text -> Either PandocError Pandoc
readMD = runPure . readMarkdown def
    { readerStandalone = True
    , readerExtensions = pandocExtensions
    }
